Index: trunk/source/Lib/TLibCommon/TComWedgelet.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 625)
+++ trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 655)
@@ -175,474 +175,4 @@
 }
 
-#if !SEC_DMM2_E0146_HHIFIX
-Bool TComWedgelet::checkPredDirAbovePossible( UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset )
-{
-  WedgeResolution eContDWedgeRes = g_dmmWedgeResolution[(UInt)g_aucConvertToBit[uiPredDirBlockSize]];
-  UInt uiContDStartEndMax = 0;
-  UInt uiContDStartEndOffset = 0;
-  switch( eContDWedgeRes )
-  {
-  case( DOUBLE_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize>>1); uiContDStartEndOffset = (uiPredDirBlockOffset>>1); break; }
-  case(   FULL_PEL ): { uiContDStartEndMax =  uiPredDirBlockSize;     uiContDStartEndOffset =  uiPredDirBlockOffset;     break; }
-  case(   HALF_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize<<1); uiContDStartEndOffset = (uiPredDirBlockOffset<<1); break; }
-  }
-
-  if( m_uhOri == 2 || m_uhOri == 3 || m_uhOri == 4 )
-  {
-    UInt uiThisStartEndMax = 0;
-    switch( m_eWedgeRes )
-    {
-    case( DOUBLE_PEL ): { uiThisStartEndMax = (m_uiWidth>>1); break; }
-    case(   FULL_PEL ): { uiThisStartEndMax =  m_uiWidth;     break; }
-    case(   HALF_PEL ): { uiThisStartEndMax = (m_uiWidth<<1); break; }
-    }
-
-    UChar uhStartX = m_uhXs;
-    UChar uhStartY = m_uhYs;
-    UChar uhEndX   = m_uhXe;
-    UChar uhEndY   = m_uhYe;
-
-    if( 2 == m_uhOri )
-    {
-      std::swap( uhStartX, uhEndX );
-      std::swap( uhStartY, uhEndY );
-    }
-
-    UInt uiScaledEndX = (UInt)uhEndX;
-    Int iDeltaRes = (Int)eContDWedgeRes - (Int)m_eWedgeRes;
-    if( iDeltaRes > 0 ) { uiScaledEndX <<=  iDeltaRes; }
-    if( iDeltaRes < 0 ) { uiScaledEndX >>= -iDeltaRes; }
-
-    if( ((UInt)uhEndY == (uiThisStartEndMax-1)) && ((uiScaledEndX-uiContDStartEndOffset) > 0 && (uiScaledEndX-uiContDStartEndOffset) < (uiContDStartEndMax-1)) )
-    {
-      return true;
-    }
-  }
-
-  return false;
-}
-
-Bool TComWedgelet::checkPredDirLeftPossible( UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset )
-{
-  WedgeResolution eContDWedgeRes = g_dmmWedgeResolution[(UInt)g_aucConvertToBit[uiPredDirBlockSize]];
-  UInt uiContDStartEndMax = 0;
-  UInt uiContDStartEndOffset = 0;
-  switch( eContDWedgeRes )
-  {
-  case( DOUBLE_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize>>1); uiContDStartEndOffset = (uiPredDirBlockOffset>>1); break; }
-  case(   FULL_PEL ): { uiContDStartEndMax =  uiPredDirBlockSize;     uiContDStartEndOffset =  uiPredDirBlockOffset;     break; }
-  case(   HALF_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize<<1); uiContDStartEndOffset = (uiPredDirBlockOffset<<1); break; }
-  }
-
-  if( m_uhOri == 1 || m_uhOri == 2 || m_uhOri == 5 )
-  {
-    UInt uiThisStartEndMax = 0;
-    switch( m_eWedgeRes )
-    {
-    case( DOUBLE_PEL ): { uiThisStartEndMax = (m_uiHeight>>1); break; }
-    case(   FULL_PEL ): { uiThisStartEndMax =  m_uiHeight;     break; }
-    case(   HALF_PEL ): { uiThisStartEndMax = (m_uiHeight<<1); break; }
-    }
-
-    UChar uhStartX = m_uhXs;
-    UChar uhStartY = m_uhYs;
-    UChar uhEndX   = m_uhXe;
-    UChar uhEndY   = m_uhYe;
-
-    if( 1 == m_uhOri || 5 == m_uhOri )
-    {
-      std::swap( uhStartX, uhEndX );
-      std::swap( uhStartY, uhEndY );
-    }
-
-    UInt uiScaledEndY = (UInt)uhEndY;
-    Int iDeltaRes = (Int)eContDWedgeRes - (Int)m_eWedgeRes;
-    if( iDeltaRes > 0 ) { uiScaledEndY <<=  iDeltaRes; }
-    if( iDeltaRes < 0 ) { uiScaledEndY >>= -iDeltaRes; }
-
-    if( ((UInt)uhEndX == (uiThisStartEndMax-1)) && ((uiScaledEndY-uiContDStartEndOffset) > 0 && (uiScaledEndY-uiContDStartEndOffset) < (uiContDStartEndMax-1)) )
-    {
-      return true;
-    }
-  }
-
-  return false;
-}
-
-Void TComWedgelet::getPredDirStartEndAbove( UChar& ruhXs, UChar& ruhYs, UChar& ruhXe, UChar& ruhYe, UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset, Int iDeltaEnd )
-{
-  ruhXs = 0;
-  ruhYs = 0;
-  ruhXe = 0;
-  ruhYe = 0;
-
-  // get start/end of reference (=this) wedgelet
-  UInt uiRefStartX = (UInt)getStartX();
-  UInt uiRefStartY = (UInt)getStartY();
-  UInt uiRefEndX   = (UInt)getEndX();
-  UInt uiRefEndY   = (UInt)getEndY();
-
-  WedgeResolution eContDWedgeRes = g_dmmWedgeResolution[(UInt)g_aucConvertToBit[uiPredDirBlockSize]];
-  UInt uiContDStartEndMax = 0;
-  UInt uiContDStartEndOffset = 0;
-  switch( eContDWedgeRes )
-  {
-  case( DOUBLE_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize>>1); uiContDStartEndOffset = (uiPredDirBlockOffset>>1); break; }
-  case(   FULL_PEL ): { uiContDStartEndMax =  uiPredDirBlockSize;     uiContDStartEndOffset =  uiPredDirBlockOffset;     break; }
-  case(   HALF_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize<<1); uiContDStartEndOffset = (uiPredDirBlockOffset<<1); break; }
-  }
-  Int iContDMaxPos = (Int)uiContDStartEndMax - 1;
-
-  // swap if start/end if line orientation is not from top to bottom
-  if( 2 == (UInt)getOri() )
-  {
-    std::swap( uiRefStartX, uiRefEndX );
-    std::swap( uiRefStartY, uiRefEndY );
-  }
-
-  // calc slopes
-  Int iA_DeltaX = (Int)uiRefEndX - (Int)uiRefStartX;
-  Int iA_DeltaY = (Int)uiRefEndY - (Int)uiRefStartY;
-
-  // get aligned end x value of ref wedge
-  UInt uiScaledRefEndX = uiRefEndX;
-  Int iDeltaRes = (Int)eContDWedgeRes - (Int)m_eWedgeRes;
-  if( iDeltaRes > 0 ) { uiScaledRefEndX <<=  iDeltaRes; }
-  if( iDeltaRes < 0 ) { uiScaledRefEndX >>= -iDeltaRes; }
-
-  assert( uiScaledRefEndX >= uiContDStartEndOffset );
-  Int iAlignedRefEndX = (Int)uiScaledRefEndX - (Int)uiContDStartEndOffset;
-
-  // special for straight vertical wedge
-  if( iA_DeltaX == 0 )
-  {
-    ruhXs = (UChar)iAlignedRefEndX;
-    ruhYs = 0;
-
-    Int iXe = iAlignedRefEndX + iDeltaEnd;
-    if( iXe < 0 )
-    {
-      ruhXe = 0;
-      ruhYe = (UChar)min( max( (iContDMaxPos + iXe), 0 ), iContDMaxPos );
-
-      return;
-    }
-    else if( iXe > iContDMaxPos )
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)min( max( (iContDMaxPos - (iXe - iContDMaxPos)), 0 ), iContDMaxPos );
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iXe;
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-  }
-
-  // special for straight horizontal short bottom line
-  if( iA_DeltaY == 0 )
-  {
-    switch( (UInt)getOri() )
-    {
-    case( 2 ):
-      {
-        ruhXs = (UChar)(iAlignedRefEndX-1);
-        ruhYs = 0;
-        ruhXe = 0;
-        ruhYe = (UChar)min( max( iDeltaEnd, 0 ), iContDMaxPos );
-
-        return;
-      }
-    case( 3 ):
-      {
-        ruhXs = (UChar)(iAlignedRefEndX+1);
-        ruhYs = 0;
-        ruhXe = (UChar)iContDMaxPos;
-        ruhYe = (UChar)min( max( -iDeltaEnd, 0 ), iContDMaxPos );
-
-        std::swap( ruhXs, ruhXe );
-        std::swap( ruhYs, ruhYe );
-        return;
-      }
-    default:
-      {
-        assert( 0 );
-        return;
-      }
-    }
-  }
-
-  // set start point depending on slope
-  if( abs( iA_DeltaX ) >= abs( iA_DeltaY ) ) { if( iA_DeltaX < 0 ) { ruhXs = (UChar)(iAlignedRefEndX-1); ruhYs = 0; }
-                                                if( iA_DeltaX > 0 ) { ruhXs = (UChar)(iAlignedRefEndX+1); ruhYs = 0; } }
-  else                                                             { ruhXs = (UChar)(iAlignedRefEndX);   ruhYs = 0;   }
-
-  // calc end point and determine orientation
-  Int iVirtualEndX = (Int)ruhXs + roftoi( (Double)iContDMaxPos * ((Double)iA_DeltaX / (Double)iA_DeltaY) );
-
-  if( iVirtualEndX < 0 )
-  {
-    Int iYe = roftoi( (Double)(0 - (Int)ruhXs) * ((Double)iA_DeltaY / (Double)iA_DeltaX) ) + iDeltaEnd;
-    if( iYe < (Int)uiContDStartEndMax )
-    {
-      ruhXe = 0;
-      ruhYe = (UChar)max( iYe, 0 );
-
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)min( (iYe - iContDMaxPos), iContDMaxPos );
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-  }
-  else if( iVirtualEndX > iContDMaxPos )
-  {
-    Int iYe = roftoi( (Double)(iContDMaxPos - (Int)ruhXs) * ((Double)iA_DeltaY / (Double)iA_DeltaX) ) - iDeltaEnd;
-    if( iYe < (Int)uiContDStartEndMax )
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)max( iYe, 0 );
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)max( (iContDMaxPos - (iYe - iContDMaxPos)), 0 );
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-  }
-  else
-  {
-    Int iXe = iVirtualEndX + iDeltaEnd;
-    if( iXe < 0 )
-    {
-      ruhXe = 0;
-      ruhYe = (UChar)max( (iContDMaxPos + iXe), 0 );
-
-      return;
-    }
-    else if( iXe > iContDMaxPos )
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)max( (iContDMaxPos - (iXe - iContDMaxPos)), 0 );
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iXe;
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-  }
-}
-
-Void TComWedgelet::getPredDirStartEndLeft( UChar& ruhXs, UChar& ruhYs, UChar& ruhXe, UChar& ruhYe, UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset, Int iDeltaEnd )
-{
-  ruhXs = 0;
-  ruhYs = 0;
-  ruhXe = 0;
-  ruhYe = 0;
-
-  // get start/end of reference (=this) wedgelet
-  UInt uiRefStartX = (UInt)getStartX();
-  UInt uiRefStartY = (UInt)getStartY();
-  UInt uiRefEndX   = (UInt)getEndX();
-  UInt uiRefEndY   = (UInt)getEndY();
-
-  WedgeResolution eContDWedgeRes = g_dmmWedgeResolution[(UInt)g_aucConvertToBit[uiPredDirBlockSize]];
-  UInt uiContDStartEndMax = 0;
-  UInt uiContDStartEndOffset = 0;
-  switch( eContDWedgeRes )
-  {
-  case( DOUBLE_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize>>1); uiContDStartEndOffset = (uiPredDirBlockOffset>>1); break; }
-  case(   FULL_PEL ): { uiContDStartEndMax =  uiPredDirBlockSize;     uiContDStartEndOffset =  uiPredDirBlockOffset;     break; }
-  case(   HALF_PEL ): { uiContDStartEndMax = (uiPredDirBlockSize<<1); uiContDStartEndOffset = (uiPredDirBlockOffset<<1); break; }
-  }
-  Int iContDMaxPos = (Int)uiContDStartEndMax - 1;
-
-  // swap if start/end if line orientation is not from left to right
-  if( 1 == (UInt)getOri() || 5 == (UInt)getOri() )
-  {
-    std::swap( uiRefStartX, uiRefEndX );
-    std::swap( uiRefStartY, uiRefEndY );
-  }
-
-  Int iL_DeltaX = (Int)uiRefEndX - (Int)uiRefStartX;
-  Int iL_DeltaY = (Int)uiRefEndY - (Int)uiRefStartY;
-
-  UInt uiScaledRefEndY = uiRefEndY;
-  Int iDeltaRes = (Int)eContDWedgeRes - (Int)m_eWedgeRes;
-  if( iDeltaRes > 0 ) { uiScaledRefEndY <<=  iDeltaRes; }
-  if( iDeltaRes < 0 ) { uiScaledRefEndY >>= -iDeltaRes; }
-
-  assert( uiScaledRefEndY >= uiContDStartEndOffset );
-  Int iAlignedRefEndY = (Int)uiScaledRefEndY - (Int)uiContDStartEndOffset;
-
-  // special for straight horizontal wedge
-  if( iL_DeltaY == 0 )
-  {
-    ruhXs = 0;
-    ruhYs = (UChar)iAlignedRefEndY;
-
-    Int iYe = iAlignedRefEndY - iDeltaEnd;
-    if( iYe < 0 )
-    {
-      ruhXe = (UChar)min( max( (iContDMaxPos + iYe), 0 ), iContDMaxPos );
-      ruhYe = 0;
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else if( iYe > iContDMaxPos )
-    {
-      ruhXe = (UChar)min( max( (iContDMaxPos - (iYe - iContDMaxPos)), 0 ), iContDMaxPos );
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)iYe;
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-  }
-
-  // special for straight vertical short right line
-  if( iL_DeltaX == 0 )
-  {
-    switch( (UInt)getOri() )
-    {
-    case( 1 ):
-      {
-        ruhXs = 0;
-        ruhYs = (UChar)(iAlignedRefEndY+1);
-        ruhXe = (UChar)min( max( iDeltaEnd, 0 ), iContDMaxPos );
-        ruhYe = (UChar)iContDMaxPos;
-
-        return;
-      }
-    case( 2 ):
-      {
-        ruhXs = 0;
-        ruhYs = (UChar)(iAlignedRefEndY-1);
-        ruhXe = (UChar)min( max( -iDeltaEnd, 0 ), iContDMaxPos );
-        ruhYe = 0;
-
-        std::swap( ruhXs, ruhXe );
-        std::swap( ruhYs, ruhYe );
-        return;
-      }
-    default:
-      {
-        assert( 0 );
-        return;
-      }
-    }
-  }
-
-  // set start point depending on slope
-  if( abs( iL_DeltaY ) >= abs( iL_DeltaX ) ) { if( iL_DeltaY < 0 ) { ruhYs = (UChar)(iAlignedRefEndY-1); ruhXs = 0; }
-                                               if( iL_DeltaY > 0 ) { ruhYs = (UChar)(iAlignedRefEndY+1); ruhXs = 0; } }
-  else                                       {                       ruhYs = (UChar)(iAlignedRefEndY);   ruhXs = 0;   }
-
-  // calc end point and determine orientation
-  Int iVirtualEndY = (Int)ruhYs + roftoi( (Double)iContDMaxPos * ((Double)iL_DeltaY / (Double)iL_DeltaX) );
-
-  if( iVirtualEndY < 0 )
-  {
-    Int iXe = roftoi( (Double)(0 - (Int)ruhYs ) * ((Double)iL_DeltaX / (Double)iL_DeltaY) ) - iDeltaEnd;
-    if( iXe < (Int)uiContDStartEndMax )
-    {
-      ruhXe = (UChar)max( iXe, 0 );
-      ruhYe = 0;
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)min( (iXe - iContDMaxPos), iContDMaxPos );
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-  }
-  else if( iVirtualEndY > iContDMaxPos )
-  {
-    Int iXe = roftoi( (Double)(iContDMaxPos - (Int)ruhYs ) * ((Double)iL_DeltaX / (Double)iL_DeltaY) ) + iDeltaEnd;
-    if( iXe < (Int)uiContDStartEndMax )
-    {
-      ruhXe = (UChar)max( iXe, 0 );
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)max( (iContDMaxPos - (iXe - iContDMaxPos)), 0 );
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-  }
-  else
-  {
-    Int iYe = iVirtualEndY - iDeltaEnd;
-    if( iYe < 0 )
-    {
-      ruhXe = (UChar)max( (iContDMaxPos + iYe), 0 );
-      ruhYe = 0;
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-    else if( iYe > iContDMaxPos )
-    {
-      ruhXe = (UChar)max( (iContDMaxPos - (iYe - iContDMaxPos)), 0 );
-      ruhYe = (UChar)iContDMaxPos;
-
-      return;
-    }
-    else
-    {
-      ruhXe = (UChar)iContDMaxPos;
-      ruhYe = (UChar)iYe;
-
-      std::swap( ruhXs, ruhXe );
-      std::swap( ruhYs, ruhYe );
-      return;
-    }
-  }
-}
-#endif
-
 Void TComWedgelet::xGenerateWedgePattern()
 {
Index: trunk/source/Lib/TLibCommon/TComWedgelet.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 625)
+++ trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 655)
@@ -50,22 +50,11 @@
 enum DIM_IDX
 {
-#if SEC_DMM2_E0146_HHIFIX
   DMM1_IDX = 0,
   DMM3_IDX = 1,
   DMM4_IDX = 2,
   RBC_IDX  = 3
-#else
-  DMM1_IDX = 0,
-  DMM2_IDX = 3,
-  DMM3_IDX = 1,
-  DMM4_IDX = 2,
-  RBC_IDX  = 4
-#endif
 };
-#if SEC_DMM2_E0146_HHIFIX
+
 #define DMM_NUM_TYPE   3
-#else
-#define DMM_NUM_TYPE   4
-#endif
 #define RBC_NUM_TYPE   1
 #define DIM_NUM_TYPE   (DMM_NUM_TYPE+RBC_NUM_TYPE)
@@ -86,7 +75,4 @@
 #define DMM_NO_WEDGEINDEX       MAX_UINT
 #define DMM_NUM_WEDGE_REFINES   8
-#if !SEC_DMM2_E0146_HHIFIX
-#define DMM2_DELTAEND_MAX       4
-#endif
 #define DMM3_SIMPLIFY_TR        1
 
@@ -151,11 +137,4 @@
   Bool  checkInvIdentical( Bool* pbRefPattern );
 
-#if !SEC_DMM2_E0146_HHIFIX
-  // functions for DMM2 prediction
-  Bool  checkPredDirAbovePossible( UInt uiPredDirBlockSize, UInt uiPredDirBlockOffsett );
-  Bool  checkPredDirLeftPossible ( UInt uiPredDirBlockSize, UInt uiPredDirBlockOffsett );
-  Void  getPredDirStartEndAbove( UChar& ruhXs, UChar& ruhYs, UChar& ruhXe, UChar& ruhYe, UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset, Int iDeltaEnd );
-  Void  getPredDirStartEndLeft ( UChar& ruhXs, UChar& ruhYs, UChar& ruhXe, UChar& ruhYe, UInt uiPredDirBlockSize, UInt uiPredDirBlockOffset, Int iDeltaEnd );
-#endif
 };  // END CLASS DEFINITION TComWedgelet
 
Index: trunk/source/Lib/TLibCommon/TComWeightPrediction.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 625)
+++ trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 655)
@@ -53,6 +53,4 @@
 class TComWeightPrediction
 {
-  wpScalingParam  m_wp0[3], m_wp1[3];
-
 public:
   TComWeightPrediction();
Index: trunk/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- trunk/source/Lib/TLibCommon/TypeDef.h	(revision 625)
+++ trunk/source/Lib/TLibCommon/TypeDef.h	(revision 655)
@@ -92,9 +92,14 @@
                                               // QC_CU_NBDV_D0181
                                               // SEC_DEFAULT_DV_D0112
-                                              // MTK_DVMCP_FIX_E0172               1 // fix the mismatch between software and WD for DV derivation from DVMCP blocks, issue 2 in JCT3V-E0172
+                                              // MTK_DVMCP_FIX_E0172       fix the mismatch between software and WD for DV derivation from DVMCP blocks, issue 2 in JCT3V-E0172
+                                              // SEC_SIMPLIFIED_NBDV_E0142 Simplified NBDV, JCT3V-E0142 and JCT3V-E0190
+                                              // MTK_NBDV_TN_FIX_E0172     fix the issue of DV derivation from the temporal neighboring blocks, issue 7 in JCT3V-E0172
+                                              // MTK_TEXTURE_MRGCAND_BUGFIX_E0182  Bug fix for TEXTURE MERGING CANDIDATE     , JCT3V-E0182
 #define H_3D_ARP                          1   // Advanced residual prediction (ARP), JCT3V-D0177
 #define H_3D_IC                           1   // Illumination Compensation, JCT3V-B0045, JCT3V-C0046, JCT3V-D0060
                                               // Unifying rounding offset, for IC part, JCT3V-D0135
                                               // Full Pel Interpolation for Depth, HHI_FULL_PEL_DEPTH_MAP_MV_ACC
+                                              // SHARP_ILLUCOMP_REFINE_E0046
+                                              // MTK_CLIPPING_ALIGN_IC_E0168       // To support simplify bi-prediction PU with identical motion checking, JCT3V-E0168
 
 #if H_3D_NBDV
@@ -103,4 +108,7 @@
                                               // MERL_D0166: Reference view selection in NBDV & Bi-VSP
                                               // MERL_C0152: Basic VSP
+                                              // NBDV_DEFAULT_VIEWIDX_BUGFIX Bug fix for invalid default view index for NBDV
+                                              // NTT_DoNBDV_VECTOR_CLIP_E0141 disparity vector clipping in DoNBDV, JCT3V-E0141 and JCT3V-E0209
+
 #endif
 
@@ -112,4 +120,7 @@
                                               // LG_D0092: Multiple VSP candidate allowed
                                               // MTK_VSP_FIX_ALIGN_WD_E0172
+                                              // NTT_VSP_ADAPTIVE_SPLIT_E0207 adaptive sub-PU partitioning in VSP, JCT3V-E0207
+                                              // NTT_VSP_DC_BUGFIX_E0208 bugfix for sub-PU based DC in VSP, JCT3V-E0208
+                                              // NTT_VSP_COMMON_E0207_E0208 common part of JCT3V-E0207 and JCT3V-E0208
 #define H_3D_IV_MERGE                     1   // Inter-view motion merge candidate
                                               // HHI_INTER_VIEW_MOTION_PRED 
@@ -139,77 +150,37 @@
                                               // FIX_SDC_ENC_RD_WVSO_D0163
                                               // MTK_SAMPLE_BASED_SDC_D0110
-
-
-
-/////////////////////////////////////////////////////////////////////////////////////////
-///////////////////////////////////   HTM-8.0 INTEGRATIONS //////////////////////////////
-/////////////////////////////////////////////////////////////////////////////////////////
-
-#define SHARP_ILLUCOMP_REFINE_E0046       1
-#define MTK_FAST_TEXTURE_ENCODING_E0173   1   // Fast merge mode decision and early CU determination for texture component of dependent view, JCT3V-E0173
-#define MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170            1   // Progressive MV Compression, JCT3V-E0170
-#define LGE_INTER_SDC_E0156               1   // Enable inter SDC for depth coding
-
-#if H_3D_IC
-#define MTK_CLIPPING_ALIGN_IC_E0168       1   // To support simplify bi-prediction PU with identical motion checking, JCT3V-E0168
-#endif
-
-#if H_3D_NBDV
-#define NBDV_DEFAULT_VIEWIDX_BUGFIX       1  // Bug fix for invalid default view index for NBDV
-#define MTK_RVS_BUGFIX_E0172              1  // Bug fix for issues caused by reference view selection, JCT3V-E0172
-#define MTK_TEXTURE_MRGCAND_BUGFIX_E0182  1  // Bug fix for TEXTURE MERGING CANDIDATE     , JCT3V-E0182
-
-#if MTK_RVS_BUGFIX_E0172
-#define MTK_DIVMC_FIX_E0172               1 // fix the issue of derivation of disparity inter-view merge candidate, issue 5 in JCT3V-E0172
-#define MTK_NBDV_TN_FIX_E0172             1 // fix the issue of DV derivation from the temporal neighboring blocks, issue 7 in JCT3V-E0172
-#endif // MTK_RVS_BUGFIX_E0172
-
-#if H_3D_NBDV_REF
-#define NTT_DoNBDV_VECTOR_CLIP_E0141      1   // disparity vector clipping in DoNBDV, JCT3V-E0141 and JCT3V-E0209
-#define SEC_SIMPLIFIED_NBDV_E0142         1   // Simplified NBDV, JCT3V-E0142 and JCT3V-E0190
-#endif
-#endif // H_3D_NBDV
-
+                                              // SEC_DMM2_E0146_HHIFIX Removal of DMM2 from DMMs
+                                              // ZJU_DEPTH_INTRA_MODE_E0204 Simplified Binarization for depth_intra_mode
+                                              // KWU_SDC_SIMPLE_DC_E0117 Simplified DC calculation for SDC
+                                              // SCU_HS_DMM4_REMOVE_DIV_E0242 DMM4 Division Removal
+                                              // LGE_SDC_REMOVE_DC_E0158 Removal of DC mode from SDC
+                                              // LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX 1   Removal of overlap between DMM3 and DMM1
+
+#define H_3D_INTER_SDC                    1   // INTER SDC, Inter simplified depth coding
+                                              // LGE_INTER_SDC_E0156  Enable inter SDC for depth coding
+#define H_3D_FCO                          0   // Flexible coding order for 3D
+
+
+
+// OTHERS
+                                              // MTK_SONY_PROGRESSIVE_MV_COMPRESSION_E0170 // Progressive MV Compression, JCT3V-E0170
+#define H_3D_REN_MAX_DEV_OUT              0   // Output maximal possible shift deviation 
+#define H_3D_FAST_TEXTURE_ENCODING        1   // Fast merge mode decision and early CU determination for texture component of dependent view, JCT3V-E0173
+                                              // MTK_FAST_TEXTURE_ENCODING_E0173
 #if H_3D_DIM
-#define SEC_DMM2_E0146_HHIFIX             1   // Removal of DMM2 from DMMs
-#define ZJU_DEPTH_INTRA_MODE_E0204        1   // Simplified Binarization for depth_intra_mode
-#define KWU_SDC_SIMPLE_DC_E0117           1   // Simplified DC calculation for SDC
-#define SCU_HS_DMM4_REMOVE_DIV_E0242      1   // DMM4 Division Removal
-#define SCU_HS_FAST_DEPTH_INTRA_E0238_HHIFIX     1   // Fast DMM and RBC Mode Selection
-#endif
-
-#if H_3D_VSP
-#define NTT_VSP_COMMON_E0207_E0208        1 // common part of JCT3V-E0207 and JCT3V-E0208
-#if NTT_VSP_COMMON_E0207_E0208
-#define NTT_VSP_DC_BUGFIX_E0208           1 // bugfix for sub-PU based DC in VSP, JCT3V-E0208
-#define NTT_VSP_VECTOR_CLIP_E0208         1 // disparity vector clipping on fetching depth map in VSP, JCT3V-E0208
-#define NTT_VSP_ADAPTIVE_SPLIT_E0207      1 // adaptive sub-PU partitioning in VSP, JCT3V-E0207
-#endif
-#endif
-
-#define H_3D_REN_MAX_DEV_OUT              0  // Output maximal possible shift deviation 
-
-/// FIXES
-#define H_3D_FIX_BVSP                     1  // DV from NBDV instead of DoNBDV should be used
-#define H_3D_FIX_TICKET_036               1  // fix for ticket #36
-#define H_3D_FIX_REN                      1  // fix of erroneous inpainting for renderer
-#define H_3D_FIX_REN_WARNING              1  // fix of warning related to camera parameter precision
-
-#define H_3D_FIX_UINT_WARNING             1  // explicit in VSD
+#define H_3D_FAST_DEPTH_INTRA             1   // Fast DMM and RBC Mode Selection
+                                              // SCU_HS_FAST_DEPTH_INTRA_E0238_HHIFIX
+#endif
+
+
+// Rate Control
+#define KWU_FIX_URQ                       1
+#define KWU_RC_VIEWRC_E0227               0  ///< JCT3V-E0227, view-wise target bitrate allocation
+#define KWU_RC_MADPRED_E0227              0  ///< JCT3V-E0227, inter-view MAD prediction
+
 #endif // H_3D
 
 
-/////////////////////////////////////////////////////////////////////////////////////////
-///////////////////////////////////   HTM-8.1 INTEGRATIONS //////////////////////////////
-/////////////////////////////////////////////////////////////////////////////////////////
-
-// Please put HTM-8.1 Integration defines here, when possible 
-
-
-/// FIXES
-#if H_MV
-#define H_MV_FIX_LID_PIC_HASH_SEI_T40                      1   // Fix wrong layer_id in decoded picture hash SEI 
-#define H_MV5                                              1   // Update to MV-HEVC 5 HLS
-#endif
+
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   DERIVED DEFINES ///////////////////////////////////  
@@ -223,22 +194,12 @@
 #define H_3D_VSO_RM_ASSERTIONS            0   // Output VSO assertions
 #define H_3D_VSO_SYNTH_DIST_OUT           0   // Output of synthesized view distortion instead of depth distortion in encoder output
-
 #define H_3D_VSO_FIX                      0   // This fix should be enabled after verification 
-
-#endif
-////   ****** Neighbouring block-based Disparity Vector  *********
+#endif
+
+////   ****** neighbouring block-based disparity vector  *********
 #if H_3D_NBDV
-#if SEC_SIMPLIFIED_NBDV_E0142
 #define DVFROM_LEFT                       0
 #define DVFROM_ABOVE                      1
 #define IDV_CANDS                         2
-#else
-#define DVFROM_LEFTBELOW                  0
-#define DVFROM_LEFT                       1
-#define DVFROM_ABOVERIGHT                 2
-#define DVFROM_ABOVE                      3
-#define DVFROM_ABOVELEFT                  4
-#define IDV_CANDS                         5
-#endif
 #endif
 
@@ -247,4 +208,5 @@
 #define H_3D_ARP_WFNR                     3
 #endif
+
 ///// ***** DEPTH INTRA MODES *********
 #if H_3D_DIM
@@ -256,12 +218,5 @@
                                               // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
                                               // LG_ZEROINTRADEPTHRESI_A0087
-#if H_3D_DIM_SDC
-#define LGE_SDC_REMOVE_DC_E0158           1   // Removal of DC mode from SDC
-#endif
-#if H_3D_DIM_DMM
-#define LGE_PKU_DMM3_OVERLAP_E0159_HHIFIX 1   // Removal of overlap between DMM3 and DMM1
-#endif
-#endif
-
+#endif
 ///// ***** VIEW SYNTHESIS PREDICTION *********
 #if H_3D_VSP
@@ -273,4 +228,18 @@
 #endif
 
+#endif
+
+///// ***** ILLUMATION COMPENSATION *********
+#if H_3D_IC
+#define IC_REG_COST_SHIFT                 7
+#define IC_CONST_SHIFT                    5
+#define IC_SHIFT_DIFF                     12
+#endif
+
+///// ***** FCO *********
+#if H_3D_FCO
+#define H_3D_FCO_VSP_DONBDV_E0163               1   // Adaptive depth reference for flexible coding order
+#else
+#define H_3D_FCO_VSP_DONBDV_E0163               0   // Adaptive depth reference for flexible coding order
 #endif
 
@@ -300,6 +269,14 @@
 #define TICKET_1090_FIX                             1
 
+#if KWU_FIX_URQ
+#if RATE_CONTROL_LAMBDA_DOMAIN
 #define RC_FIX                                      1  /// suggested fix for M0036
 #define RATE_CONTROL_INTRA                          1  ///< JCTVC-M0257, rate control for intra 
+#endif
+#else
+#define RC_FIX                                      1  /// suggested fix for M0036
+#define RATE_CONTROL_INTRA                          1  ///< JCTVC-M0257, rate control for intra 
+#endif
+
 
 #define MAX_CPB_CNT                     32  ///< Upper bound of (cpb_cnt_minus1 + 1)
@@ -484,9 +461,5 @@
 
 #if H_3D_VSO_DIST_INT
-#if H_3D_FIX_TICKET_036
 typedef       Int64            Dist;       ///< RDO distortion
-#else
-typedef       Int              Dist;       ///< RDO distortion
-#endif
 typedef       Int64            Dist64; 
 #define       RDO_DIST_MIN     MIN_INT
@@ -793,15 +766,8 @@
   enum ScalabilityType
   {
-#if H_MV5
 #if H_3D
     DEPTH_ID = 0,    
 #endif    
     VIEW_ORDER_INDEX  = 1,
-#else
-    VIEW_ID  = 0,
-#if H_3D
-    DEPTH_ID = 1,    
-#endif    
-#endif
   };
 #endif
Index: trunk/source/Lib/TLibDecoder/SEIread.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/SEIread.cpp	(revision 625)
+++ trunk/source/Lib/TLibDecoder/SEIread.cpp	(revision 655)
@@ -315,4 +315,5 @@
 
   /* restore primary bitstream for sei_message */
+  getBitstream()->deleteFifo();
   delete getBitstream();
   setBitstream(bs);
Index: trunk/source/Lib/TLibDecoder/SyntaxElementParser.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/SyntaxElementParser.cpp	(revision 625)
+++ trunk/source/Lib/TLibDecoder/SyntaxElementParser.cpp	(revision 655)
@@ -58,9 +58,9 @@
   if (length < 10)
   {
-    fprintf( g_hTrace, "%-50s u(%d)  : %d\n", pSymbolName, length, rValue ); 
+    fprintf( g_hTrace, "%-50s u(%d)  : %u\n", pSymbolName, length, rValue ); 
   }
   else
   {
-    fprintf( g_hTrace, "%-50s u(%d) : %d\n", pSymbolName, length, rValue ); 
+    fprintf( g_hTrace, "%-50s u(%d) : %u\n", pSymbolName, length, rValue ); 
   }
   fflush ( g_hTrace );
@@ -77,5 +77,5 @@
 #endif
   fprintf( g_hTrace, "%8lld  ", g_nSymbolCounter++ );
-  fprintf( g_hTrace, "%-50s ue(v) : %d\n", pSymbolName, rValue ); 
+  fprintf( g_hTrace, "%-50s ue(v) : %u\n", pSymbolName, rValue ); 
   fflush ( g_hTrace );
 }
